// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once

#include "ISCW_FMemberReference.h"
#include "ISCW_UEdGraphPin.h"
#include "ISCW_UFunction.h"
#include "ISCW_UK2Node.h"
#include "ISCW_FProperty.h"
#include <memory>
#include <string>

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{
	class ISCW_UK2Node_BaseMCDelegate : public virtual ISCW_UK2Node
	{
	public:
		virtual ~ISCW_UK2Node_BaseMCDelegate() = default;

		virtual ISCW_FMemberReferencePtr GetDelegateReference() const = 0;

		virtual ISCW_UEdGraphPinPtr GetDelegatePin() const = 0;

		virtual ISCW_UFunctionPtr GetDelegateSignature() const = 0;
		
		virtual ISCW_FPropertyPtr GetProperty() const = 0;
	};

	using ISCW_UK2Node_BaseMCDelegateConstPtr = shared_ptr<const ISCW_UK2Node_BaseMCDelegate>;
	using ISCW_UK2Node_BaseMCDelegatePtr = shared_ptr<ISCW_UK2Node_BaseMCDelegate>;
} // namespace Sourcify